<template>
  <v-app>
    <v-app-bar
      app
      color="#292961"
      dark
    >
      <div class="d-flex align-center">
        <Tanuki :loading='false'></Tanuki>
      </div>
      <div class="d-flex text-h4 ml-2">GitLab Jump Start</div>

      <v-spacer></v-spacer>
      <v-btn class="accent black--text" v-if="isAuthenticated" @click="logout(vueInstance)">Logout</v-btn>
      <v-btn v-else @click="login()">Log In</v-btn>
    </v-app-bar>

    <v-dialog
      v-model="dialog"
      persistent
      max-width="290"
    >
      <v-card>
        <v-card-title class="headline justify-center">
                <Tanuki :loading='loading' :size="80"></Tanuki>
        </v-card-title>
        <v-card-actions class="pb-4">
          <v-spacer></v-spacer>
          <v-btn
            color="blue darken-4"
            outlined
            text
            @click="authenticate(vueInstance)"
          >
            Authenticate With GitLab
          </v-btn>
          <v-spacer></v-spacer>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <v-main>
      <v-container>
        <router-view/>
      </v-container>
    </v-main>
  </v-app>
</template>

<style src='@koumoul/vjsf/lib/VJsf.css'></style>
<style src='@koumoul/vjsf/dist/main.css'></style>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator'
import { Getter, Action } from 'vuex-class'
import Tanuki from './components/Tanuki.vue'
import log from 'loglevel'

@Component({
  components: { Tanuki }
})
export default class App extends Vue {
  @Getter isAuthenticated!: boolean
  @Getter loading!: boolean
  @Action authenticate!: (vue: any) => void
  @Action logout!: () => void

  created (): void {
    const logLevel = this.$route?.query?.log as string
    if (logLevel) {
      switch (logLevel) {
        case 'trace': log.setLevel(log.levels.TRACE)
          break
        case 'debug': log.setLevel(log.levels.DEBUG)
          break
        case 'info': log.setLevel(log.levels.INFO)
          break
        case 'warn': log.setLevel(log.levels.WARN)
          break
        case 'error': log.setLevel(log.levels.ERROR)
          break
      }
    }
  }

  get dialog (): boolean {
    return !this.isAuthenticated
  }

  get vueInstance (): Vue {
    return this
  }
}
</script>
